var exifasr_directorySeparator = null;

function startDisplay() {
	var fileName;
	var sb = document.getElementById('statusbar');
	var pb = document.getElementById('progressbar');
	if (pb)  pb.setAttribute('mode', 'undetermined');
	clearTexts('outputDiv');
	if (document.getElementById('remote_file').value != '') {
		if (sb)  sb.setAttribute('label', 'Processing remote URL...'); 
		fileName = document.getElementById('remote_file').value;
	} else {
		if (sb)  sb.setAttribute('label', 'Processing local file...'); 
		fileName = document.getElementById('local_file').value;
	}

	if (fileName.indexOf('file://') == 0) {
		if (!exifasr_directorySeparator)  setExifDirectorySeparator();
		var re1 = new RegExp('^file://(localhost|127.0.0.1)?/', '')
		var re2 = new RegExp('/', 'g'); 
		fileName = fileName.replace(re1, '').replace(re2, exifasr_directorySeparator);
	}
	
	try {
		processFile(fileName, null, 'outputDiv', document.getElementById('maker').checked, document.getElementById('image').checked);
	} catch (e) {
//		var output = new Array();
//		for (var a in e) {
//			output.push(a + ': ' + e[a]);
//		}
//		alert(e + '\n' + output.join('\n'));
		if (e.name == 'NS_ERROR_FAILURE'  &&  e.location.indexOf('read8') != -1) {
			alert('A network error was encountered. Please check your connection to the Internet.');
		} else {
			alert('An unrecoverable error was encountered while processing the specified file. I would appreciate it if you could email the image link and a copy of the next popup alert to me at araskin@allstream.net so that I can fix the problem.');
			alert('Result:         ' + '0x' + e.result.toString(16) + '\n' + 
				  'Name:           ' + e.name + '\n' +
				  'Message:        ' + e.message + '\n' + 
				  'File name:      ' + e.filename + '\n' +
				  'Line number:    ' + e.lineNumber + '\n' +
//				  'Column number : ' + e.columnNumber + '\n' +
				  'Location:       ' + e.location + '\n' +
				  'Data:           ' + (e.data ? e.data : 'no') //+ '\n' +
//				  'Inner:          ' + (e.inner ? e.inner : 'no')
			);
		} 
	}
	if (sb)  sb.setAttribute('label', 'Done!'); 
	if (pb)  pb.setAttribute('mode', 'determined');
	if (pb)  pb.setAttribute('value', '0');
}	// startDisplay()

function pickFile() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
				.createInstance(nsIFilePicker);
	fp.init(window, 'Select a File', nsIFilePicker.modeOpen);
	fp.appendFilter('JPEG Files', '*.jpeg; *.jpg');
	fp.appendFilters(nsIFilePicker.filterImages);
//	fp.appendFilters(nsIFilePicker.filterHTML | nsIFilePicker.filterImages | nsIFilePicker.filterText | nsIFilePicker.filterAll);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK) {
		var thefile = fp.file;
  		document.getElementById('local_file').value = thefile.path;
		clearText('fileDiv');
		displayText(cleanExifStringData(thefile.path), 'fileDiv');
		saveURL();
		clearURL();
	}
}	// pickFile()

/*
function printOutput() {
	var frame = document.getElementById("outputDiv");
	var req = frame.QueryInterface(Components.interfaces.nsIInterfaceRequestor);
	var wbprint = req.getInterface(Components.interfaces.nsIWebBrowserPrint);
	var settings = PrintUtils.getPrintSettings(); // from chrome://global/content/printUtils.js
	wbprint.print(settings, null);
}	// printOutput()
*/

function copyToClipboard(text) {
	var gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
							.getService(Components.interfaces.nsIClipboardHelper);
	gClipboardHelper.copyString(text.replace(/<html:/gi, '<').replace(/<\/html:/gi, '</').replace(/ xmlns:html="http:\/\/www.w3.org\/1999\/xhtml"/g, ''));
}	// copyToClipboard()

function handleLocalChanged(value) {
	clearText('fileDiv');
	displayText(cleanExifStringData(value), 'fileDiv');
	saveURL();
	clearURL();
}	// handleLocalChanged()

function handleRemoteChanged(value) {
	clearText('fileDiv');
	displayText(cleanExifStringData(value), 'fileDiv');
	clearFile();
}	// handleRemoteChanged()

var exifasr_savedURL = document.getElementById('remote_file').value;

function saveURL() {
	var s = document.getElementById('remote_file').value;
	if (s != '')  exifasr_savedURL = s;
}	// saveURL()

function restoreURL() {
	document.getElementById('remote_file').value = exifasr_savedURL;
	clearFile();
	clearText('fileDiv');
	displayText(cleanExifStringData(exifasr_savedURL), 'fileDiv');
}	// restoreURL()

function clearURL() {
	document.getElementById('remote_file').value = '';
}	// clearURL()

function clearFile() {
	document.getElementById('local_file').value = '';
}	// clearFile()

function _handleExifImagePicked(url) {
	if (url.indexOf('file://') == 0) {
		if (!exifasr_directorySeparator)  setExifDirectorySeparator();
		var re1 = new RegExp('^file://(localhost|127.0.0.1)?/', '')
		var re2 = new RegExp('/', 'g'); 
		url = url.replace(re1, '').replace(re2, exifasr_directorySeparator);
		document.getElementById('local_file').value = url;
		clearURL();
	} else {
		saveURL();
		document.getElementById('remote_file').value = url;
		clearFile();
	}
	clearText('fileDiv');
	displayText(cleanExifStringData(url), 'fileDiv');
	startDisplay();
}

function exifViewDiv(checked, divExt) {
	var div = document.getElementById('outputDiv_' + divExt);
	if (div)  div.style.display = (checked ? 'none' : '');
}	// exifViewDiv()

function setExifDirectorySeparator() {
	try {
		const id = 'exif_viewer@mozilla.doslash.org';
		var ext = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(id)
					.getItemLocation(id); 
		// ext is an instance of nsIFile, so ext.path contains the directory as a string

		// determine the file-separator
		if (ext.path.search(/\\/) != -1) {
			exifasr_directorySeparator = '\\';		// Windows
		} else if (ext.path.search(/\//) != -1) {
			exifasr_directorySeparator = '/';		// Unix
		} else {
			exifasr_directorySeparator = ':';		// Mac
		}
	} catch (e) {
		exifasr_directorySeparator = '\\';
	}
}	// setExifDirectorySeparator() 